<%@ page language="java" import="java.util.*,com.ibm.ut.help.common.*,com.ibm.ut.help.common.web.*,com.ibm.ut.help.common.security.IAuthenticator, com.ibm.ut.commenter.*,com.ibm.ut.commenter.service.*, javax.servlet.http.*, org.eclipse.core.runtime.Preferences;" contentType="text/html;UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%
	String query = request.getQueryString();
	Locale locale = LocaleUtil.getLocale(request);
	IAuthenticator auth = AuthenticationService.getAuthenticator();
	
	
	Properties props = auth.getAuthenticationDetails(request);
	String name = auth.getUser(request)!=null ? auth.getUser(request) : "";
	String email = "";
	if (props!=null)
		email = props.getProperty("email")!=null ? props.getProperty("email") : "";
%>
<html>
    <head>
        <link rel="stylesheet" type="text/css" href="../dojotoolkit/dijit/themes/tundra/tundra.css" />
        <link rel="STYLESHEET" type="text/css" href="../topic/com.ibm.ut.help.common/css/utcommon.css" />
        <script type="text/javascript" src="../dojotoolkit/dojo/dojo.js" djConfig="parseOnLoad:true"></script>
        <script type="text/javascript" src="../topic/com.ibm.ut.help.common/scripts/utcommon.js"></script>        
        <style type="text/css">
        
            @import "../dojotoolkit/dojo/resources/dojo.css";
            @import "../dojotoolkitext/ibm/themes/jazz/jazz.css";
            @import "css/customStyles.css";
			
        </style>
        <script type="text/javascript">
            dojo.require("dijit.TitlePane");
            dojo.require("dijit.form.Select");
            dojo.require("dojo.parser");
            dojo.require("dijit.Editor");
            dojo.require("dijit.InlineEditBox");
			dojo.require("dijit.form.ValidationTextBox");
            dojo.require("dijit._editor.plugins.AlwaysShowToolbar");

			function Comment(){
				this.name='';
				this.email='';
				this.time='';
				this.state=<%=Comment.OPEN%>;
			}
	
			var text = '';
			var hold = false;
			var comment = new Comment();
	
            dojo.addOnLoad(function(){
				document.getElementById("newComment").style.display="none";
            });            
            
            function addComment()
            {
            	var uid = "";
            
            	var user = document.getElementById('user');
            	if (user!=null && user.value!=null)
            	{
            		uid+=user.value;
	            	
	            	var email = document.getElementById('email');
	            	if (email!=null && email.value!=null)
	            		uid+=","+email.value;
	            }
	            else
	            {
					uid = '<%=auth.getUser(request)%>';	            
	            }
            	
				var commentJSON = "{'id':'<%=request.getParameter("topic")%>','uid':'"+uid+"','time':'"+comment.time+"','description':'"+encodeHTML(text)+"'}";
				
				dojo.xhrPut({
					url: '../com.ibm.ut.commenter.service.CommentService',
					handleAs: "text",
					putData: commentJSON,
					load: function(data, ioArgs) {
						window.location.reload();
					},
					error: function(data, ioArgs) {
						return;
					}
				});	  
            }
            
            function editState(index,state)
            {
            	var editedComment = new Comment();
            	editedComment.state = state;
            	
            	var commentInfo = document.getElementById("commentInfo"+index);
            	editedComment.name = commentInfo.getAttribute('name');
            	editedComment.time = commentInfo.getAttribute('time');
            	
            	var commentDesc = document.getElementById("commentDesc"+index);
            	editedComment.desc = commentDesc.innerHTML;
            	
            	editComment(index,editedComment);
            }
            
            function editComment(index,comment)
            {
            	var commentXML = "<comment><name>"+comment.name+"</name><time>"+comment.time+"</time><state>"+comment.state+"</state><description>"+comment.desc+"</description></comment>";
				
				dojo.xhrPut({
					url: '../com.ibm.ut.commenter.service.CommentService<%=request.getParameter("topic")%>/'+index,
					handleAs: "text",
					putData: commentXML,
					load: function(data, ioArgs) {
						window.location.reload();
					},
					error: function(data, ioArgs) {
						return;
					}
				});	  
            }
            
            function addEditableComment(name)
            {
		       	var date = new Date();
            	var email = '<%=email%>';
            	var time = (date.getMonth()+1)+"-"+date.getDate()+"-"+date.getFullYear()+" "+date.getHours()+":"+date.getMinutes()+":"+date.getSeconds();
            	var table = document.getElementById('commentsTable');
            	var row = table.insertRow(table.rows.length);
            	var cell = row.insertCell(0);
            	
            	document.getElementById('newComment').style.display="";
            	
            	
            	var link = document.getElementById('addCommentLink');
            	link.href='javascript:void()';
            	link.style.color='gray';
            	
            	link = document.getElementById('addCommentLink2');
            	if (link!=null){
	            	link.href='javascript:void()';
	            	link.style.color='gray';
	            }
            	
            	var save = document.getElementById('saveComment');
            	save.disabled = false;
            	
            	comment.name = name;
            	comment.time = time;
            }
            
            function logIn()
            {
            	var loginDiv = document.getElementById('logInDiv');
            	loginDiv.style.display='block';	
            	var logInForm = document.getElementById('logInForm');
            	logInForm.style.display='block';	
            	
            	var logInLink = document.getElementById('logInLink');
            	logInLink.style.display='none';
            }
            
        </script>
    </head>

    <body class="jazz">    	
		<div class="jazz_clear bordered" 
			dojoType="dijit.TitlePane"
			region="leading" 
			id="discussionPane">
			<table id="commentsTable" style="width:100%;">
				<tr>
					<td>
<%	

	if (AuthenticationService.isAuthenticated(request) || auth instanceof FreeAuthenticator) {	%>
						<a href="javascript:addEditableComment('<%=name%>')" id="addCommentLink" style="float: right;font-weight: bold;margin-right: 1.6em;margin-top: 0.8em;" >Add Comment</a><br/>
<%	}else{	%>
						<a href="javascript:logIn()" id="logInLink" style="float: right;font-weight: bold;margin-right: 1.6em;margin-top: 0.8em;" >Log in to comment</a><br/>
						<form method="post" action="../com.ibm.ut.commenter.service.AuthenticationService" id="logInForm" name="logInForm" style="height:150px;width:100%;display:none">
							<div id="logInDiv" style="display:none;">
								<table>
									<tr id="formNameRow"><td><span id="formName">Name: </td><td><input name="user" id="user"onkeydown="if (event.keyCode == 13) logInForm.submit();" ></input></span></td></tr>
									<tr id="formPasswordRow"><td><span id="formPassword">Password: </td><td><input name="xword" id="xword" type="password" onkeydown="if (event.keyCode == 13) logInForm.submit();"><br/></input></span></td></tr>
									<tr id="formSubmitRow"><td></td><td><input type="submit" value="Log In"/>&nbsp;</td></tr>
								</table>
								<input type="hidden" value="./com.ibm.ut.commenter/commenter.jsp?<%=query%>" name="redirect"></input>
							</div>
						</form>
<%	}	%>
					</td>
<!--				<td style="float:right;position:absolute;right:30px;">
						<a>Collapse All</a> | <a>Expand All</a>
					</td>
-->				</tr>
<%
	List comments = Commenter.getComments(request.getParameter("topic"));
	int count = 0;
	for (int c=0;c<comments.size();c++)
	{
		boolean admin = AuthenticationService.isAdmin(request);
		Comment comment = (Comment)comments.get(c);
		if (comment.getState()!=Comment.DELETED || admin)
		{
			count++;
%>
				<tr>
					<td>
<%			if (admin)	{	%>	
						<select dojoType=dijit.form.Select 
							id=stateSelect<%=count-1%> 
							name=stateSelect 
							onChange=editState(<%=count-1%>,this.value)
							class="titlebar">
						    <option value="<%=Comment.OPEN%>" <% if (comment.getState()==Comment.OPEN){%> selected="true" <%}%>>
						        <%=MessageLibrary.getString("Open",locale)%>
						    </option>
						    <option value="<%=Comment.CLOSED%>" <% if (comment.getState()==Comment.CLOSED){%> selected="true" <%}%>>
						        <%=MessageLibrary.getString("Close",locale)%>
						    </option>
						    <option value="<%=Comment.DELETED%>" <% if (comment.getState()==Comment.DELETED){%> selected="true" <%}%>>
						        <%=MessageLibrary.getString("Delete",locale)%>
						    </option>
						</select>
<%			}	%>						
						<div id="commentInfo<%=count-1%>" name="<%=comment.getName()%>" time="<%=comment.getTime()%>"/>
							<div class="jazz_clear" 
								dojoType="dijit.TitlePane"
								region="leading" 
								id="comment<%=(count)%>"					
								title="<%=(count)%>.&nbsp;&nbsp;&nbsp;&nbsp;<%=comment.getName()%>&nbsp;&nbsp;&nbsp;&nbsp;<%=comment.getTime()%>">	
								<span class="commentDescription" id="commentDesc<%=c%>"><%=comment.getEncodedDescription()%></span><br/><br/>
							</div>
						</div>
					</td>
				</tr>
<%		}
	}	%>
				<tr>
					<td><div id="newComment"/>	
<%	if (auth instanceof FreeAuthenticator) {	%>
						<table style="position:absolute;left:50px;" class="dijitTitlePaneTextNode tablebar">
							<tr id="formRow">
								<td>Name: </td>
								<td><input id="user" name="user" value="<%=name%>" dojotype="dijit.form.ValidationTextBox" required="true"/></input></td>
								<td>Email: </td>
								<td><input id="email" name="email" value="<%=email%>" dojotype="dijit.form.ValidationTextBox"/></input></td>
							</tr>
						</table>						
<%	}	%>
						<div class="jazz_clear" 
							dojoType="dijit.TitlePane"
							region="leading" 
							id="newCommentPane"					
							title="<%=(count+1)%>. <%=auth.getAuthenticationDetails(request)!=null ? auth.getAuthenticationDetails(request).getProperty("name") : ""%>">
							<div dojoType="dijit.Editor" id="commentEditor" onChange="text = arguments[0];" style="height:120px;">

							</div>
						</div>
					</td>
				</tr>
<%	if ((AuthenticationService.isAuthenticated(request) || auth instanceof FreeAuthenticator) && count>0) {	%>
				<tr><td><a style="float: right;font-weight: bold;margin-right: 1.6em;margin-top: 0.8em;" href="javascript:addEditableComment('<%=name%>')" id="addCommentLink2">Add Comment</a><br/></td></tr>
<%	}  %>
			</table>
			<input type="submit" onclick="addComment()" id="saveComment" disabled style="position:absolute;float:right;right:30px;" value="Save"/>

		</div>
	</body>
</html>
       