<%@ page language="java" import="java.io.IOException, org.eclipse.core.runtime.*,org.eclipse.help.HelpSystem, com.ibm.ut.help.common.security.*, com.ibm.ut.help.common.web.*,com.ibm.ut.help.common.*, java.util.*, com.ibm.war.updater.activator.*, com.ibm.war.updater.utils.*, javax.servlet.http.*, org.eclipse.core.runtime.Preferences;" contentType="text/html;UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%
	Properties props = new Properties();
	props.setProperty("waradmins","true");
	HTMLUtil.handleAuth(request,response,props);
		

    //Localization of Strings
	Locale locale = LocaleUtil.getLocale(request);
	
	boolean showBanner = request.getParameter("banner")==null || request.getParameter("banner").equals("true");

%>

<html>
    <head>
        <title><%=MessageLibrary.getString("AdministrativeAccessManagement", locale)%></title>
<% 	if (showBanner){ 	%>
        <link rel="STYLESHEET" type="text/css" href="../topic/com.ibm.ccl.help.webapp.war.updater/banner/banner.css" />
<%	}	%>
        <link rel="STYLESHEET" type="text/css" href="../topic/com.ibm.ccl.help.webapp.war.updater/css/admin.css" />
        <link rel="STYLESHEET" type="text/css" href="../topic/com.ibm.ut.help.common/css/utcommon.css" />
        <script type="text/javascript" src="../dojotoolkit/dojo/dojo.js" djConfig="parseOnLoad:true">
        </script>
        <script type="text/javascript" src="../topic/com.ibm.ut.help.common/scripts/utcommon.js"></script>
        
        <style type="text/css">
        
            @import "../dojotoolkit/dojo/resources/dojo.css";
            @import "../dojotoolkitext/ibm/themes/jazz/jazz.css";
            @import "../dojotoolkitext/ibm/themes/jazz/Grid.css";
            @import "css/customStyles.css";
            			li{
				list-style :none
			} 
			
			.relativeDiv{
				position:relative;
			}
			
            label {
                float: left;
                margin-top: 5px
            }
            
            input, select {
                float: right;
                margin-top: 5px
            }
            
            form {
                width: 300px;
                height: 400px;
            } #passwordform {
                margin-left: 30%
            }
        </style>
        <script type="text/javascript">
            dojo.require("dijit.layout.BorderContainer");
            dojo.require("dijit.layout.ContentPane");
            dojo.require("dijit.TitlePane");
			dojo.require("dijit.Tooltip");
			dojo.require("dijit.Dialog");
            dojo.require("dijit.form.Form");
            dojo.require("dijit.form.Button");
            dojo.require("dijit.form.Select");
            dojo.require("dijit.form.ComboBox");
            dojo.require("dijit.form.TextBox");
            dojo.require("dijit.form.ValidationTextBox");
			dojo.require("dojox.grid.DataGrid");
			dojo.require("dojo.data.ItemFileWriteStore");
			dojo.require("dojo.parser");
	
            dojo.require("dojo._base.xhr");
            dojo.addOnLoad(function(){
            
				dojo.connect(dojo.byId('xword'), "onkeyup", validateXword);
				dojo.connect(dojo.byId('xword2'), "onkeyup", validateXword);
				
				dojo.connect(usersGridStore, "onNew", gridEdited);
				dojo.connect(usersGridStore, "onSet", gridEdited);
				dojo.connect(usersGridStore, "onDelete", gridEdited);
				
				loadType();	

            });
            
            function gridEdited(param)
            {
            	if(param)
            	{
	            	usersGridStore.save({
	            		onComplete:function(){
				            usersGridStore.close();
				            usersGridStore.fetch();
				            usersGrid.setStore(usersGridStore, { name: '*' });    
	            		}
	            	});
	            }
            }
            
            function securityChanged()
            {
				var select = dijit.byId('securitySelect')
				var type = select.value;
		        setType(type);
            }
            
            
            function generateID(name)
            {
            	var date = new Date();
            	return name+'-'+date.getTime();
            }
            
			dojo.registerModulePath("ibm", "../../dojotoolkitext/ibm");
			dojo.require("ibm.data.RESTItemStore");
            
            function hide(){
          		if(dijit.byId("actions").value == 'Create User')
          			{
          			dojo.attr('password','required','false');
            		dojo.byId("extrafield").style.display = "none";
            		dojo.byId("extrafieldisa").style.display = "inline";
                       	
            	}else{
            		display();
            	}
            }
            
            function display(){
          	 	 dojo.attr('password','required','true');
         	   	dojo.byId("extrafield").style.display = "inline";
         	   dojo.byId("extrafieldisa").style.display = "none";
      	
            }
             
            function addUser()
            {
            	var uid = generateID('User');
            	usersGridStore.newItem({name:uid,uid:uid,isAdmin:false});
           
            	editPass(uid);
            }
            
            function removeUser(name)
            {
 				usersGridStore.fetch({
					query:{name:name},
					onItem:function(item){
						usersGridStore.deleteItem(item);
					}
				});
			}           	
             
            function validateXword(){
            
            	var xword = dijit.byId('xword');
            	var xword2 = dijit.byId('xword2');
            
            	if (xword.textbox.value != xword2.textbox.value)
            	{
               		dijit.byId('xwordDialogOK').attr('disabled',true);
            		return false;
                }
                if(!xword.validate() || !xword2.validate())
                {
               		dijit.byId('xwordDialogOK').attr('disabled',true);
                	return false;
            	}
            	dijit.byId('xwordDialogOK').attr('disabled',false);	
             	return true;                                        
            }
            
            
            var disabledDiv;
			var usersGridStore;
			var usersGridLayout = [
				{
					name: 'Name',
					field: 'title',
					styles:'',
					width: '90%'
				},
				{
					name: 'Admin',
					field: 'isAdmin',
					styles: '',
					width: '10%'
				}
			];

            function loadType() {
				
				dojo.xhrGet({
					url: '../com.ibm.ccl.help.webapp.war.updater.servlets.AccessManagementService/@type',
					handleAs: "json",
					load: function(data, ioArgs) {
						
						var select = dijit.byId('securitySelect');
						
						if (data.type=='local')
							select.attr('value','local');
						else
							select.attr('value','remote');
					},
					error: function(data, ioArgs) {

						return;
					}
				});	
			}   

            function setType(type) {
				
				dojo.xhrPost({
					url: '../com.ibm.ccl.help.webapp.war.updater.servlets.AccessManagementService/@type',
					handleAs: "text",
					postData: "{type:"+type+"}",
					load: function(data, ioArgs){},
					error: function(data, ioArgs) {}
				});	
			}            

			
			function addLink(data)
			{
				data = data.substring(0,data.length-1);
				data = data.substring(0,data.lastIndexOf("]"));
				data+="\n,\n\t{title:'<a href=\"javascript:addUser()\"><%=MessageLibrary.getString("AddUser",locale)%></a>',uid:'add',isAdmin:null,children:[]}]}";
				return data;
			}
			
			// URL formatter - if an anchor is in the data, display it as a hyperlink in the grid
			function urlFormatter(name)
			{
				if (name.indexOf("&lt;a")>-1)
				{
					name = name.replace(/&lt;/g,'<');
					return name;
				}
				return name;
			}
			
			// Remove Button formatter - add a remove button to this cell
			function removeButtonFormatter(name)
			{
				var count = usersGridStore._arrayOfAllItems.length;
				if (count>1)
					return '<a href="javascript:removeUser(\''+name+'\')" class="gridRemove" style="width:25px;height:25px;" title="<%=MessageLibrary.getString("Remove",locale)%>">&nbsp;&nbsp;&nbsp;&nbsp;</a>';			
				else
					return '';
			}
			
			// Password URL formatter - add a password edit url to this cell
			function passURLFormatter(name)
			{
				return '<a href="javascript:editPass(\''+name+'\')"><%=MessageLibrary.getString("ChangePassword",locale)%></a>';
			}
			
			function fetchErr(error)
			{
				var l=1;
				alert(l);
			}
			
			function editPass(name)
			{
				document.getElementById('xword').value='';
				document.getElementById('xword2').value='';
				dijit.byId('xwordDialog').name=name;
				dijit.byId('xwordDialog').show();
			}
			
			function passEdited(name,xword)
			{
				usersGridStore.fetch({
					query:{name:name},
					onItem:function(item){
						usersGridStore.setValue(item,'xword',xword);
					}
				});
			}
			
            
        </script>
    </head>

    <body class="jazz">    
    	<span dojoType="ibm.data.RESTItemStore" 
    		jsId="usersGridStore"
    		clearOnClose="true"
    		useIdentifier="true"
    		url="../com.ibm.ccl.help.webapp.war.updater.servlets.AccessManagementService"
    		saveURL="../com.ibm.ccl.help.webapp.war.updater.servlets.AccessManagementService">
    	</span>
    	<span dojoType="dojo.data.ItemFileWriteStore" 
    		jsId="addGridStore" 
    		data="{title:'test',identifier:'title',items:[{title:'<a href=javascript:addUser() ><%=MessageLibrary.getString("Add",locale)%></a>'} ]}">
    	</span>
    	
    	<span id="admin_header_tt" dojoType="dijit.Tooltip" position="below" connectId="admin_header_img">
			<%=HelpSystem.getContext("com.ibm.ccl.help.webapp.war.updater.AdminDescription").getText()%>
    	</span>
    	<span id="type_tt" dojoType="dijit.Tooltip" position="below" connectId="type_img">
			<%=HelpSystem.getContext("com.ibm.ccl.help.webapp.war.updater.AuthenticationType").getText()%>
    	</span>
    	
    	
<%
	if (showBanner){
%>
		<!-- BEGIN IBM BANNER -->
		<div class="bannerContainer">
			<div class="headerContainer">
				<div class="headerCenter">
					<div class="headerLeft"></div>
					<div class="headerRight"></div>
				</div>
			</div>
			<div class="bannerContent">
				<div class="helpLogo"></div>
				<div class="helpTitle"><%=MessageLibrary.getString("AdministrativeAccessManagement", locale)%></div>
				<div class="ibmLogo"></div>
			</div>
		</div>
	    <!-- END IBM BANNER -->

		<table class="banneredTable" cellspacing="15">

<%	}else{	%>	
		<table class="mainTable" cellspacing="15">
		<tr>		
			<td><span class="mainTitle"><%=MessageLibrary.getString("AdministrativeAccessManagement", locale)%></span></td>
		</tr>
<%	}	%>
		<tr style="height:2%;">
			<td>
				<p class="mainDescription">
					<%=HelpSystem.getContext("com.ibm.ccl.help.webapp.war.updater.AdministrativeAccessManagementPageDesc").getText()%>
				</p>
			</td>
		</tr>
			<tr>
				<td>
					<div class="jazz_clear" 
						dojoType="dijit.TitlePane"
						region="leading" 
						id="remoteAdminPane"
						title="<%=MessageLibrary.getString("Authentication",locale)%>">
                        <span style="position:relative;top:1px;">
                            <%=MessageLibrary.getString("Type",locale)%>:
                        </span>
                        
						<select dojoType="dijit.form.Select" id="securitySelect" name="securitySelect" onChange="securityChanged()">
						    <option value="local">
						        Local Access Only
						    </option>
						    <option value="remote">
						        Role Based Security
						    </option>
						</select>
                        <img class="tooltipSource"
							id="type_img" 
							src="../topic/com.ibm.ut.help.common/images/tooltipSourceFade.gif",
							onmouseover="replaceAttribute(this,'src','../topic/com.ibm.ut.help.common/images/tooltipSourceFade.gif','../topic/com.ibm.ut.help.common/images/tooltipSource.gif')"
							onmouseout="replaceAttribute(this,'src','../topic/com.ibm.ut.help.common/images/tooltipSource.gif','../topic/com.ibm.ut.help.common/images/tooltipSourceFade.gif')"></img>
					</div>
				</td>
			</tr>

	        <tr>
				<td class="left">
					<div class="jazz_clear" dojoType="dijit.TitlePane"
						region="leading" 
						id="userTitlePane"
						title="<%=MessageLibrary.getString("UserEntries",locale)%>">
					
						<div class="relativeDiv">
							<table id="usersGrid"
								jsId="usersGrid"
								dojoType="dojox.grid.DataGrid"
								query="{ name: '*' }"
								store="usersGridStore"
								clientSort="true"
								rowSelector="16px"
								selectionMode="none"
								autoheight="true">
								<thead>
									<tr>
										<th width="18%" field="name" editable="true">
											<%=MessageLibrary.getString("Name",locale)%>
										</th>
										<th width="17%" field="name" formatter="passURLFormatter">
											<%=MessageLibrary.getString("Password",locale)%>
										</th>
<%
		IConfigurationElement configs[] = Platform.getExtensionRegistry().getConfigurationElementsFor("com.ibm.ut.help.common.security");
		int width = 50/ (configs.length>0 ? configs.length : 1);
		for (int c=0;c<configs.length;c++){	%>						
										<th width="<%=width%>%" field="<%=configs[c].getAttribute("name")+"_group"%>" editable="true" cellType="dojox.grid.cells.Bool">
											<%=configs[c].getAttribute("description",locale.toString())%>
										</th>
<%		}	%>										
										<th width="5%" field="name" formatter="removeButtonFormatter">
											&nbsp;
										</th>
									</tr>
								</thead>
							</table>
							<table id="addGrid"
								jsId="addGrid"
								dojoType="dojox.grid.DataGrid"
								query="{ title: '*' }"
								store="addGridStore"
								clientSort="true"
								rowSelector="16px"
								selectionMode="none"
								autoheight="true"
								class="no-header">
								<thead>
									<tr>
										<th width="100%" field="title" formatter="urlFormatter">
											Name
										</th>
									</tr>
								</thead>
							</table>
							<img class="tooltipSource"
								style="position:absolute;top:5px;right:24px;"
								id="admin_header_img" 
								src="../topic/com.ibm.ut.help.common/images/tooltipSourceFade.gif",
								onmouseover="replaceAttribute(this,'src','../topic/com.ibm.ut.help.common/images/tooltipSourceFade.gif','../topic/com.ibm.ut.help.common/images/tooltipSource.gif')"
								onmouseout="replaceAttribute(this,'src','../topic/com.ibm.ut.help.common/images/tooltipSource.gif','../topic/com.ibm.ut.help.common/images/tooltipSourceFade.gif')"></img>						
						</div>
					</div>
				</td>
			</tr>
		</table>
		
		<div dojoType="dijit.Dialog" id="xwordDialog" title="Change Password" style="overflow: hidden;">
			<table>
				<tr>
					<td>New Password</td>
					<td><input type="password" name="xword" required="true" dojotype="dijit.form.ValidationTextBox" id="xword" /></td>
				</tr>
				<tr>	
					<td>Confirm Password</td>
					<td><input type="password" name="xword2" required="true" dojotype="dijit.form.ValidationTextBox" id="xword2" /></td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td>
						<button id="xwordDialogOK" dojoType="dijit.form.Button" type="submit" 
							onclick="passEdited(dijit.byId('xwordDialog').name,dijit.byId('xword').textbox.value)" disabled="true">OK</button>
						<button id="xwordDialogCancel" dojoType="dijit.form.Button" type="submit" onclick="javascript:dijit.byId('xwordDialog').hide()">Cancel</button>
					</td>
				</tr>	
			</table>
		</div>
	</body>
</html>
       