﻿/*
 * Licensed Material - Property of IBM 
 * (C) Copyright IBM Corp. 2010 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure 
 * restricted by GSA ADP Schedule Contract with IBM Corp. 
 */

// --------------------------------------------------
// Localized Strings -- User Assistance Web Delivery 
// --------------------------------------------------

{
updateInProgressMsg : "Nota: non fare clic sul pulsante Indietro del browser mentre l'aggiornamento è in corso",
installInProgressMsg : "Nota: non fare clic sul pulsante Indietro del browser mentre l'installazione è in corso",
uninstallInProgressMsg : "Nota: non fare clic sul pulsante Indietro del browser mentre la disinstallazione è in corso",
publicSiteslbl : "Siti pubblici",
internalSiteslbl : "Siti interni",
siteNamelbl : "Nome",
siteLoclbl : "Posizione",
availFeaturelbl : "Funzioni disponibili",
installFeaturelbl : "Funzioni installate",
featureDesclbl : "Descrizione della funzione",
includedFeatureslbl : "Funzioni incluse",
installlbl : "Installa",
removelbl : "Elimina",
featurelbl : "Funzione",
installSizelbl : "Dimensione di installazione",
statuslbl : "Stato",
addSitelbl : "Aggiungi sito interno",
viewEditSitelbl : "Visualizza e modifica sito interno",
siteTypelbl : "Tipo di sito",
namelbl : "Nome",
oklbl : "OK",
cancellbl : "Annulla",
restartmsg : "Il sistema della guida verrà riavviato adesso per applicare le modifiche",
installfailedmsg : "Non è stato possibile installare la funzione",
errorConnectmsg : "Non è stato possibile stabilire la connessione all'url del sito",
noFeaturemsg : "Non è stata individuata alcuna funzione",
searchFeaturemsg : "Ricerca di aggiornamenti",
seeLogMsg : "Per ulteriori dettagli, consultare il file di log",

featureDescriptionlbl : "Descrizione della funzione",
includedFeaturelbl: "Funzioni incluse",
clearlbl: "Cancella",
messagelbl: "Messaggio",
typelbl : "Tipo",
warninglbl : "Avvertenza",
messageerrorlbl : "Errore",
infolbl : "Informazioni",
installingFeaturelbl : "Installazione della funzione",
uninstallingFeaturelbl : "Disinstallazione della funzione",
updatesAppliedlbl : "Aggiornamenti applicati",
sitesSavedlbl : "Siti salvati correttamente",
savingSitelbl : "Salvataggio del sito locale",
locallbl : "Locale",
remotelbl : "Remoto",
processFeatureslbl : "Elaborazione delle funzioni...",
restartWaitlbl : "Attendere che il sistema della guida venga riavviato per applicare le modifiche.",
platformResetlbl : "La piattaforma è stata reimpostata. È necessario riavviare il prodotto per applicare le modifiche.",
retrieveFeatureslbl : "Richiamo delle funzioni...",
contactServerlbl : "Connessione con il server...",
searchForUpdateslbl : "Ricerca degli aggiornamenti...",
prepareInstalllbl : "Preparazione per l'installazione...",
prepareUninstalllbl : "Preparazione per la disinstallazione...",
selectUpdateSitelbl : "Selezionare i siti in cui cercare gli aggiornamenti.",
errorResettinglbl : "Errore nel riavvio del sistema della guida",
errorConnectingPlatformlbl: "Errore durante la connessione alla piattaforma",
runinbckgrndlbl : "Esegui in background",
errorFFBrowserSecuritylbl : "Impossibile accedere ai file locali a causa delle impostazioni di sicurezza del browser.<br/>Eseguire i seguenti passi per accedere ai file locali:<br/>(1) Nel campo URL della finestra del browser, immettere about:config. La pagina delle preferenze di configurazione viene visualizzata nel browser.<br/>(2) Nella pagina delle preferenze di configurazione visualizzata, fare clic con il pulsante destro del mouse e selezionare Nuovo >Booleano dal menu di scelta rapida.<br/>(3) Immettere 'signed.applets.codebase_principal_support' (senza i doppi apici) come nuovo nome della preferenza.<br/>(4) Fare clic su OK.<br/>(5)Provare ad aggiungere di nuovo il file 'site.xml'.",
errorRelativePathNotAllowed : "Impossibile caricare il file '{0}': i percorsi relativi non sono consentiti. Fornire un percorso assoluto a questo file.",
errorFileNotFound : "File '{0}' non trovato.",
errorIEBrowserSecuritylbl : "Impossibile accedere ai file locali a causa delle impostazioni di sicurezza del browser.<br/>Eseguire i seguenti passi per accedere ai file locali:<br/>(1) Fare clic su Strumenti > Opzioni Internet nella finestra di Internet Explorer.<br/>(2) Nella scheda Protezione, fare clic su Livello personalizzato.<br/>(3) Abilitare l'impostazione Inizializza e esegui script controlli ActiveX non contrassegnati come sicuri.<br/>(4) Fare clic su OK.<br/>(5)Provare ad aggiungere di nuovo il file 'site.xml'.",
errorNoFilePermission : "Impossibile accedere al file locale '{0}' a causa delle autorizzazioni del file. Accertarsi che il file e/o le directory padre siano leggibili.",
infoOperationRunning : "Un'operazione è in corso di elaborazione.<br/>Attendere...",
errorReadFeatureList : "Si è verificato un errore durante la lettura delle funzioni selezionate",
infoInstallDependencyFeature : "La funzione selezionata richiede {0}.<br/><br/>Per visualizzare gli argomenti della guida, anche {1} deve essere installato.",
infoUninstallDependencyFeature : "{0} richiede la funzione selezionata per eseguire la disinstallazione.<br/><br/>Anche {1} deve essere disinstallato.",
confirmCancelInstall : "L'annullamento dell'installazione corrente, ripristinerà lo stato precedente; tale operazione richiederà alcuni minuti. Si desidera proseguire?",
readPendingTask : "Lettura di qualsiasi operazione in sospeso dall'ultima sessione.<br/>Attendere...",
readRollbackFeatureList : "Lettura delle informazioni della funzione per ripristinare l'installazione corrente.<br/>Attendere...",
errorReadPendingTaskFailed : "Si è verificato un errore durante la lettura dell'operazione in sospeso dall'ultima sessione",
infoCancelInProgress : "Annullamento dell'operazione corrente.<br/>Attendere...",
allsiteslbl : "Tutti i siti",
publicsiteslbl : "Siti pubblici",
internalsiteslbl : "Siti interni",
installedappcontentlbl : "Contenuto applicazione installata",
downloadfeatures : "Download delle funzioni...",
installfeatures : "Installazione software in corso...",
uninstallfeatures : "Rimozione software in corso...",
updatefeatures : "Aggiornamento software in corso...",
showstatuslbl : "Mostra dettagli",
aboutLocalHelpSystem : "Informazioni sul sistema della guida locale...",
lhuTitle : "Programma di aggiornamento della guida locale",
dependencyFound : "È stata trovata una dipendenza"
}
